Crazy Eddies GUI System: CEGUI::FalagardMultiLineEditbox Class Reference

Crazy Eddies GUI System 0.7.6

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Attributes | Protected Member Functions | Protected Attributes | Static Protected Attributes
CEGUI::FalagardMultiLineEditbox Class Reference

MultiLineEditbox class for the FalagardBase module. More...

Inheritance diagram for CEGUI::FalagardMultiLineEditbox:
[legend]
Collaboration diagram for CEGUI::FalagardMultiLineEditbox:
[legend]

List of all members.

## Public Member Functions
| FalagardMultiLineEditbox (const String &type)
| Constructor.
Rect | getTextRenderArea (void) const
| Return a Rect object describing, in un-clipped pixels, the window relative area that the text should be rendered in to.
void | render ()
| Populate render cache.
void | update (float elapsed)
| perform any time based updates for this WindowRenderer.
bool | isCaretBlinkEnabled () const
| return whether the blinking caret is enabled.
float | getCaretBlinkTimeout () const
| return the caret blink timeout period (only used if blink is enabled).
void | setCaretBlinkEnabled (bool enable)
| set whether the blinking caret is enabled.
void | setCaretBlinkTimeout (float seconds)
| set the caret blink timeout period (only used if blink is enabled).
## Static Public Attributes
static const utf8 | TypeName []
static const String | UnselectedTextColourPropertyName
| Name of property to use to obtain unselected text rendering colour.
static const String | SelectedTextColourPropertyName
| Name of property to use to obtain selected text rendering colour.
static const String | ActiveSelectionColourPropertyName
| Name of property to use to obtain active selection rendering colour.
static const String | InactiveSelectionColourPropertyName
| Name of property to use to obtain inactive selection rendering colour.
static const float | DefaultCaretBlinkTimeout
| The default timeout (in seconds) used when blinking the caret.
## Protected Member Functions
void | cacheEditboxBaseImagery ()
| Perform rendering of the widget control frame and other 'static' areas. This method should not render the actual text. Note that the text will be rendered to layer 4 and the selection brush to layer 3, other layers can be used for rendering imagery behind and infront of the text & selection..
void | cacheCaratImagery (const Rect &textArea)
| Render the carat.
void | cacheTextLines (const Rect &dest_area)
| Render text lines.
colour | getUnselectedTextColour () const
| return the colour to be used for rendering Editbox text oustside of the selected region.
colour | getActiveSelectionColour () const
| return the colour to be used for rendering the selection highlight when the editbox is active.
colour | getInactiveSelectionColour () const
| return the colour to be used for rendering the selection highlight when the editbox is inactive.
colour | getSelectedTextColour () const
| return the colour to be used for rendering Editbox text falling within the selected region.
colour | getOptionalPropertyColour (const String &propertyName) const
| Return a colour object fetched from the named property if it exists, else a default colour (black).
## Protected Attributes
bool | d_blinkCaret
| true if the caret imagery should blink.
float | d_caretBlinkTimeout
| time-out in seconds used for blinking the caret.
float | d_caretBlinkElapsed
| current time elapsed since last caret blink state change.
bool | d_showCaret
| true if caret should be shown.
## Static Protected Attributes
static FalagardMultiLineEditboxProperties::BlinkCaret | d_blinkCaretProperty
static FalagardMultiLineEditboxProperties::BlinkCaretTimeout | d_blinkCaretTimeoutProperty

## Detailed Description

MultiLineEditbox class for the FalagardBase module.

This class requires LookNFeel to be assigned. The LookNFeel should provide the following:

States:

- Enabled - Rendering for when the editbox is in enabled and is in read-write mode.
- ReadOnly - Rendering for when the editbox is in enabled and is in read-only mode.
- Disabled - Rendering for when the editbox is disabled.

NamedAreas: TextArea - area where text, selection, and carat imagery will appear. TextAreaHScroll - TextArea when only horizontal scrollbar is visible. TextAreaVScroll - TextArea when only vertical scrollbar is visible. TextAreaHVScroll - TextArea when both horizontal and vertical scrollbar is visible.

PropertyDefinitions (optional, defaults will be black):

- NormalTextColour - property that accesses a colour value to be used to render normal unselected text.
- SelectedTextColour - property that accesses a colour value to be used to render selected text.
- ActiveSelectionColour - property that accesses a colour value to be used to render active selection highlight.
- InactiveSelectionColour - property that accesses a colour value to be used to render inactive selection highlight.

Imagery Sections:

- Carat

Child Widgets: Scrollbar based widget with name suffix "__auto_vscrollbar__" Scrollbar based widget with name suffix "__auto_hscrollbar__"

## Member Function Documentation

void CEGUI::FalagardMultiLineEditbox::cacheCaratImagery | ( | const Rect & | textArea | ) | `[protected]`

Render the carat.

Returns:
  Nothing

void CEGUI::FalagardMultiLineEditbox::cacheEditboxBaseImagery | ( |  | ) | `[protected]`

Perform rendering of the widget control frame and other 'static' areas. This method should not render the actual text. Note that the text will be rendered to layer 4 and the selection brush to layer 3, other layers can be used for rendering imagery behind and infront of the text & selection..

Returns:
  Nothing.

colour CEGUI::FalagardMultiLineEditbox::getActiveSelectionColour | ( |  | ) | const`[protected]`

return the colour to be used for rendering the selection highlight when the editbox is active.

Returns:
  colour value describing the colour to be used.

colour CEGUI::FalagardMultiLineEditbox::getInactiveSelectionColour | ( |  | ) | const`[protected]`

return the colour to be used for rendering the selection highlight when the editbox is inactive.

Returns:
  colour value describing the colour to be used.

colour CEGUI::FalagardMultiLineEditbox::getOptionalPropertyColour | ( | const String & | propertyName | ) | const`[protected]`

Return a colour object fetched from the named property if it exists, else a default colour (black).

Parameters:

  propertyName | String object holding the name of the property to be accessed if it exists.

colour CEGUI::FalagardMultiLineEditbox::getSelectedTextColour | ( |  | ) | const`[protected]`

return the colour to be used for rendering Editbox text falling within the selected region.

Returns:
  colour value describing the colour to be used.

Rect CEGUI::FalagardMultiLineEditbox::getTextRenderArea | ( | void |  | ) | const`[virtual]`

Return a Rect object describing, in un-clipped pixels, the window relative area that the text should be rendered in to.

Returns:
  Rect object describing the area of the Window to be used for rendering text.

Implements CEGUI::MultiLineEditboxWindowRenderer.

colour CEGUI::FalagardMultiLineEditbox::getUnselectedTextColour | ( |  | ) | const`[protected]`

return the colour to be used for rendering Editbox text oustside of the selected region.

Returns:
  colour value describing the colour to be used.

void CEGUI::FalagardMultiLineEditbox::render | ( |  | ) | `[virtual]`

Populate render cache.

This method must be implemented by all window renderers and should perform the rendering operations needed for this widget. Normally using the Falagard API...

Implements CEGUI::WindowRenderer.

## Member Data Documentation

const String CEGUI::FalagardMultiLineEditbox::UnselectedTextColourPropertyName`[static]`

Name of property to use to obtain unselected text rendering colour.

type name for this widget.